import BinTree

{- ABR -}

insertion :: Ord a => a -> Tree a -> Tree a
insertion elem Empty = Node elem Empty Empty
insertion elem (Node r lt rt) | elem <= r = Node r (insertion elem lt) rt
                              | otherwise = Node r lt (insertion elem rt)

cutMax :: Ord a => Tree a -> (a, Tree a)
cutMax Empty = error "empty tree"
cutMax (Node r lt Empty) = (r, lt)
cutMax (Node r lt rt) = (m, Node r lt cutM)
                         where (m, cutM) = cutMax rt

suppression :: Ord a => a -> Tree a -> Tree a
suppression _ Empty = Empty
suppression elem (Node r lt rt) | elem < r = Node r (suppression elem lt) rt
                                | r < elem = Node r lt (suppression elem rt)
                                | otherwise = if isEmpty lt
                                              then rt
                                              else let (m, cutM) = cutMax lt
                                                       in Node m cutM rt

recherche :: Ord a => a -> Tree a -> Bool
recherche _ Empty = False
recherche elem (Node r lt rt) = elem == r || if (elem < r) then recherche elem lt else recherche elem rt 

{- AVL -}

rg :: Tree a -> Tree a
rg Empty = Empty
rg (Node e ag ad) = Node (root ad) (Node e ag (left ad)) (right ad) 

rd :: Tree a -> Tree a
rd Empty = Empty
rd (Node e ag ad) = Node (root ag) ag (Node e (right ag) ad)

{- catastrophe il faut changer la représentation des ABR pour avoir une complexité raisonnable du calcul de la hauteur ! -} 
height :: Tree a -> Int
height Empty = 0
height (Node elem ag ad) = 1 + max (height ag) (height ad)


balance :: Ord a => Tree a -> Tree a
balance a = 
    let lt = left a
        rt = right a
        in case height lt - height rt of 
            2 -> if  height (left lt) > (height (right lt))
                 then rd a
                 else rd (Node (root a) (rg lt) rt)
            -2 -> if height (right rt) >  height (left rt)
                  then rd a
                  else rg (Node (root a) lt (rd rt))
            otherwise -> a

insert :: Ord a => a -> Tree a -> Tree a
insert elem a | isEmpty a = Node elem Empty Empty
              | otherwise = if elem <= root a 
                            then balance (Node (root a) (insert elem (left a)) (right a))
                            else balance (Node (root a) (left a) (insert elem (right a)))


main = let l = [ 12, 3, 6, 89, 23, 41, 1, 24, 12, 46 ]
           a = foldl (\a x -> insertion x a) Empty l
           in do
            print $ prefixe a
            print $ prefixe (suppression 3 a)
            print $ prefixe (suppression 12 a)
            print $ recherche 23 a
            print $ recherche 11 a
